VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form Form1 
   Caption         =   "AP Pdf2Tiff ActiveX Control Library Demo!"
   ClientHeight    =   1845
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6375
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   1845
   ScaleWidth      =   6375
   StartUpPosition =   3  'Windows Default
   Begin ComctlLib.ProgressBar m_ProgressBar 
      Height          =   375
      Left            =   0
      TabIndex        =   2
      Top             =   1440
      Width           =   6375
      _ExtentX        =   11245
      _ExtentY        =   661
      _Version        =   327682
      Appearance      =   1
   End
   Begin VB.CommandButton Command2 
      Caption         =   "demo2"
      Height          =   375
      Left            =   2040
      TabIndex        =   1
      Top             =   480
      Width           =   1095
   End
   Begin VB.CommandButton Command1 
      Caption         =   "demo1"
      Height          =   375
      Left            =   480
      TabIndex        =   0
      Top             =   480
      Width           =   1095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'1.1 TIFF compression tag's definitions.
'==========================================================================================
 Const AP_TIFF_COMPRESSION_NONE = 0      'No compression.
 Const AP_TIFF_COMPRESSION_LZW = 1       '1,4,8,24bits(default 4,8,24bits)
 Const AP_TIFF_COMPRESSION_JPEG = 2      'Grayscale 8bits,24bits
 Const AP_TIFF_COMPRESSION_PACKBITS = 3  '4,8,24bits
 Const AP_TIFF_COMPRESSION_CCITTG4 = 4   '1bit(default 1bit)
 Const AP_TIFF_COMPRESSION_CCITTG3 = 5   '1bit
 Const AP_TIFF_COMPRESSION_RLE = 6       '1bit
'==========================================================================================

'1.2 Return code's definitions.
'==========================================================================================
 Const RTN_OK = 1           'Successful operation.
 Const ERR_UNKNOWN = -99    'Unknown system error.
       
 Const ERR_OVER_MAXTHREADS = -1     'Over the limit amount of threads
 Const ERR_FILE_UNEXIST = -2        'Source PDF file unexist.
 Const ERR_FILE_DAMAGED = -3        'Source PDF file is damaged.
 Const ERR_FILE_RESTRICTED = -4     'Source PDF file is restricted.
       
 Const ERR_INVALID_PAGE = -5      'The PDF page is invalid.
 Const ERR_CONVERT_FAILURE = -8   'Conversion failure.
 Const ERR_INVALID_STREAM = -9    'Invalid memory stream address.
 Const ERR_INVALID_HANDLE = -10   'Invalid converter's handle.
'==========================================================================================


 Private Type SECURITY_ATTRIBUTES
         nLength As Long
         lpSecurityDescriptor As Long
         bInheritHandle As Long
 End Type
 
 Private Declare Function GetTickCount Lib "kernel32" () As Long
 Private Declare Function CreateDirectory Lib "kernel32" Alias "CreateDirectoryA" (ByVal lpPathName As String, lpSecurityAttributes As SECURITY_ATTRIBUTES) As Long
 Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

'Defining and initilizing an AP Pdf2Tiff ActiveX Control object.
Private m_AxPdf2Tiff As New AP_PDF2TIFF.AxPdf2Tiff

'Demo1 - To convert all pages of the pdf document.
Private Sub Command1_Click()
    Dim nHandle As Long
    Dim sFileName As String
    Dim iStartTick As Long, iEndTick As Long
    Dim iPageNo, iPageCount As Long

    sFileName = "sample.pdf"
    iStartTick = GetTickCount
    
    'Open pdf document and creating a converter.
    nHandle = m_AxPdf2Tiff.apOpen(sFileName, "", "")
    Select Case nHandle
      Case ERR_OVER_MAXTHREADS
        MsgBox "Over the limit amount of threads,please waiting!"
        Exit Sub
      Case ERR_FILE_UNEXIST
        MsgBox "Source pdf file unexist!"
        Exit Sub
      Case ERR_FILE_DAMAGED
        MsgBox "Source pdf file damaged!"
        Exit Sub
      Case ERR_FILE_RESTRICTED
        MsgBox "Source pdf file restricted!"
        Exit Sub
    End Select
    
    'Setting proerties.
    m_AxPdf2Tiff.sOutDirectory = "./demo1"
    m_AxPdf2Tiff.iMultiPages = 1  'To generate multipages tiff.
    m_AxPdf2Tiff.iCompression = AP_TIFF_COMPRESSION_LZW
    m_AxPdf2Tiff.iXDPI = 130
    m_AxPdf2Tiff.iYDPI = 130
    
    'To convert all pages of the pdf document.
    iPageCount = m_AxPdf2Tiff.apGetPageCount(nHandle)
    For iPageNo = 1 To iPageCount
        m_AxPdf2Tiff.apConvertPage nHandle, iPageNo
        
        'Setting conversion's progress.
        m_ProgressBar.Value = Round((iPageNo * 1#) / iPageCount * 100)
    Next

    'Close pdf document and destory the converter.
    m_AxPdf2Tiff.apClose nHandle
   
    'To count conversion's time(ms).
    iEndTick = GetTickCount
    MsgBox "Conversion successful,it passed " + CStr(iEndTick - iStartTick) + "ms!"
End Sub

'Demo2 - To convert appointed pdf pages of the pdf document to memory stream.
Private Sub Command2_Click()
    Dim nHandle As Long
    Dim sFileName As String
    Dim iStartTick As Long, iEndTick As Long
    Dim iPos, iPageCount As Long
    Dim bBuffer() As Byte
    Dim m_Pages
    
    sFileName = "sample.pdf"
    m_Pages = Array(1, 3, 6, 8, 9, 11, 0)
    iStartTick = GetTickCount
    
    'Open pdf document and creating a converter.
    nHandle = m_AxPdf2Tiff.apOpen(sFileName, "", "")
    Select Case nHandle
      Case ERR_OVER_MAXTHREADS
        MsgBox "Over the limit amount of threads,please waiting!"
        Exit Sub
      Case ERR_FILE_UNEXIST
        MsgBox "Source pdf file unexist!"
        Exit Sub
      Case ERR_FILE_DAMAGED
        MsgBox "Source pdf file damaged!"
        Exit Sub
      Case ERR_FILE_RESTRICTED
        MsgBox "Source pdf file restricted!"
        Exit Sub
    End Select
    
    'Setting proerties.
    m_AxPdf2Tiff.iCompression = AP_TIFF_COMPRESSION_LZW
    m_AxPdf2Tiff.iXDPI = 110
    m_AxPdf2Tiff.iYDPI = 110
    m_AxPdf2Tiff.iXDimensions = 995
    m_AxPdf2Tiff.iYDimensions = 1287

    'To convert the appointed pages of the pdf document.
    iPageCount = UBound(m_Pages)
    For iPos = 0 To iPageCount - 1
       'You can save the image stream to database, to file, or to others, etc.
       m_AxPdf2Tiff.apConvertPageToStream nHandle, m_Pages(iPos)
       
       'Here,it saves the memory stream of the image to bytes buffer
       Dim attr As SECURITY_ATTRIBUTES
       ReDim bBuffer(m_AxPdf2Tiff.iStreamSize) As Byte
       CopyMemory ByVal VarPtr(bBuffer(0)), ByVal m_AxPdf2Tiff.iStreamHandle, m_AxPdf2Tiff.iStreamSize
       
       'Here,it saves the buffer to file.
       If m_AxPdf2Tiff.iStreamSize > 0 Then
          CreateDirectory "./demo2", attr
          sImgFile = "./demo2/myimg_" + CStr(m_Pages(iPos)) + ".tif"
          
          Open sImgFile For Binary As #1
          Put #1, , bBuffer
          Close #1
       End If
       
       'Setting conversion's progress.
       m_ProgressBar.Value = Round(((iPos + 1) * 1#) / iPageCount * 100)
    Next
    
    'Close pdf document and destory the converter.
    m_AxPdf2Tiff.apClose nHandle
   
    'To count conversion's time(ms).
    iEndTick = GetTickCount
    MsgBox "Conversion successful,it passed " + CStr(iEndTick - iStartTick) + "ms!"
End Sub
